

close all;
clear;
clc;
set(gca,'FontSize',12);

c=3e8;      
fc=77e9;  % carrier frequency
lamada=c/fc;% wavelength
dspace=lamada/2;
M=192;       % number of array elements
first=1;    %һԪ
x=linspace(first,first+(M-1)*dspace,M);%

SNR=15;% SNR
N=1;  % number of snapshots

Direction=[0.3 -0.3 2];% direction of sources
S=length(Direction);
A=exp(-1j*(2*pi*fc/c)*x.'*sin(Direction*pi/180));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AmplitudeP=randn(length(Direction),N);
AmplitudeV=[1 1 0.3]'; % db

K=256;               
Anglemin=-10;
Anglemax=10;       
Angle=linspace(Anglemin,Anglemax,K);
x=linspace(first,first+(M-1)*dspace,M);
Ascan=exp(-1j*(2*pi*fc/c)*x.'*sin(Angle*pi/180));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure
for i=1:10
    y=A*AmplitudeV+wgn(M,1,-SNR);     
    [P]=IAA(y,Ascan,0,0.5);
    P=(abs(P))/max(abs(P));
    plot(Angle,db(P),'b')
    hold on
end
plot(Direction,db(AmplitudeV),'ok')
hold on
plot([Direction(1),Direction(1)],[-50 10],'--k')
hold on
plot([Direction(2),Direction(2)],[-50 10],'--k')
hold on
plot([Direction(3),Direction(3)],[-50 10],'--k')
axis([-10 10 -50 10])
xlabel('Angle (degree)')
ylabel('Amplitude (dB)')
set(gca,'FontSize',12);

figure
for i=1:10
    y=A*AmplitudeV+wgn(M,1,-SNR);    
    [P]=IAA(y,Ascan,15,0.1);
    P=(abs(P))/max(abs(P));
    plot(Angle,db(P),'b')
    hold on
end
plot(Direction,db(AmplitudeV),'ok')
hold on
plot([Direction(1),Direction(1)],[-50 10],'--k')
hold on
plot([Direction(2),Direction(2)],[-50 10],'--k')
hold on
plot([Direction(3),Direction(3)],[-50 10],'--k')
axis([-10 10 -50 10])
xlabel('Angle (degree)')
ylabel('Amplitude (dB)')
set(gca,'FontSize',12);

figure
for i=1:10
    y=A*AmplitudeV+wgn(M,1,-SNR);    
%     y=y.*www;
    [P]=OL_qSPICE_spectral(y,Ascan,2,1e-3);
    P=(abs(P))/max(abs(P));
    plot(Angle,db(P),'b')
    hold on
end
plot(Direction,db(AmplitudeV),'ok')
hold on
plot([Direction(1),Direction(1)],[-50 10],'--k')
hold on
plot([Direction(2),Direction(2)],[-50 10],'--k')
axis([-10 10 -50 10])
xlabel('Angle (degree)')
ylabel('Amplitude (dB)')
set(gca,'FontSize',12);
